/****************** (c) 2002  STMicroelectronics *****************************

PROJECT : ST7

VERSION :

CREATION DATE :

AUTHOR :

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

MODIFICATIONS :

******************************************************************************/

#ifndef MS_MASS_H
#define MS_MASS_H

/********************************************/
/*			MS Transfert Protocol			*/
/********************************************/
#define   READ_PAGE_DATA   		0x2D
#define   READ_REG              0x4B
#define   GET_INT				0x78
#define   WRITE_PAGE_DATA		0xD2
#define   WRITE_REG				0xB4
#define   SET_R_W_REG_ADRS		0x87
#define   SET_CMD				0xE1
#define   Reserved				0x1E

/********************************************/
/*				MS Flash Cmd				*/
/********************************************/
#define   BLOCK_READ			0xAA
#define   BLOCK_WRITE			0x55
#define   BLOCK_END				0x33
#define   BLOCK_ERASE			0x99
#define   FLASH_STOP			0xCC

/********************************************/
/*				MS Function Cmd				*/
/********************************************/
#define	SLEEP		0x5A
#define CLEAR_BUF	0xC3
#define RESET		0x3C

/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
//		Functions exported from MS_Mass
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
extern unsigned short MS_DTC_Read_Status(void);
extern unsigned char MS_DTC_Write_Page(unsigned char buf01);
extern unsigned char MS_DTC_Read_Page(unsigned char buf01);
extern unsigned char MS_DTC_Erase(void);
extern unsigned char MS_Retry_Write_USB(void);
extern void MS_DTC_Write_USB(unsigned char buf01);
extern void MS_DTC_Read_USB(void);
extern void MS_DTC_Copy_Pages(void);
extern void MS_DTC_wCopyPages(void);
extern void MS_DTC_Mark_Pages(unsigned short Flag);
extern void MS_DTC_wMarkPages(unsigned short Flag);

extern void Format_One_Block(void);
extern unsigned char MS_Retry_Format(void);

#endif
