/**************** (c) 2000  STMicroelectronics **********************

PROJECT : USB - ST7

VERSION :  V 0.9

CREATION DATE :  02/20/2000

AUTHOR : MICROCONTROLLER DIVISION / ST San Jose

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-


LAST MODIFICATION  :  11 / 17 / 2000

******************************************************************************/

#ifndef UNICODE_H
#define UNICODE_H

#define uNUL	0x0,0x00
#define uSOH	0x1,0x00
#define uSTX	0x2,0x00
#define uETX	0x3,0x00
#define uEOT	0x4,0x00
#define uENQ	0x5,0x00
#define uACK	0x6,0x00
#define uBEL	0x7,0x00
#define uBS     0x8,0x00
#define uHT     0x9,0x00
#define uLF     0xa,0x00
#define uVT     0xb,0x00
#define uFF     0xc,0x00
#define uCR     0xd,0x00
#define uSO     0xe,0x00
#define uSI     0xf,0x00
#define uDLE	0x10,0x00
#define uDC1	0x11,0x00
#define uDC2	0x12,0x00
#define uDC3	0x13,0x00
#define uDC4	0x14,0x00
#define uNAK	0x15,0x00
#define uSYN	0x16,0x00
#define uETB	0x17,0x00
#define uCAN	0x18,0x00
#define uEM     0x19,0x00
#define uSUB	0x1a,0x00
#define uESC	0x00,0x1b
#define uFS     0x1c,0x00
#define uGS     0x1d,0x00
#define uRS     0x1e,0x00
#define uUS     0x1f,0x00
#define uSPACE	0x20,0x00

#define u!			0x21,0x00
#define uDQUOTES	0x22,0x00  // "
#define uSHARP		0x23,0x00         // #
#define uDOLLAR		0x24,0x00        // $
#define uPER		0x25,0x00           // %
#define uAND		0x26,0x00           // &
#define uSQOUTE		0x27,0x00        // '
#define uOBRACKET	0x28,0x00 // (
#define uCBRACKET	0x29,0x00 // )
#define uSTAR		0x2a,0x00          // *
#define uPLUS		0x2b,0x00          // +
#define uCOMA		0x2c,0x00          // ,
#define uMINUS		0x2d,0x00         // -
#define uPOINT		0x2e,0x00         // .
#define uSLASH		0x2f,0x00         // /

#define u0			0x30,0x00
#define u1			0x31,0x00
#define u2			0x32,0x00
#define u3			0x33,0x00
#define u4			0x34,0x00
#define u5			0x35,0x00
#define u6			0x36,0x00
#define u7			0x37,0x00
#define u8			0x38,0x00
#define u9			0x39,0x00
                    
#define uCOLON			0x3a,0x00,               //:
#define uSEMICOLON		0x3b,0x00,           //;
#define uINFERIOR		0x3c,0x00,            //<
#define uEQUAL			0x3d,0x00,               //=
#define uSUPERIOR		0x3e,0x00,            //>
#define uQUESTIONMARK	0x3f,0x00,        //?
#define uAT				0x40,0x00,                  //@

#define uA		0x41,0x00
#define uB		0x42,0x00
#define uC		0x43,0x00
#define uD		0x44,0x00
#define uE		0x45,0x00
#define uF		0x46,0x00
#define uG		0x47,0x00
#define uH		0x48,0x00
#define uI		0x49,0x00
#define uJ		0x4a,0x00
#define uK		0x4b,0x00
#define uL		0x4c,0x00
#define uM		0x4d,0x00
#define uN		0x4e,0x00
#define uO		0x4f,0x00
#define uP		0x50,0x00
#define uQ		0x51,0x00
#define uR		0x52,0x00
#define uS		0x53,0x00
#define uT		0x54,0x00
#define uU		0x55,0x00
#define uV		0x56,0x00
#define uW		0x57,0x00
#define uX		0x58,0x00
#define uY		0x59,0x00
#define uZ		0x5a,0x00
                     
#define ua		0x61,0x00
#define ub		0x62,0x00
#define uc		0x63,0x00
#define ud		0x64,0x00
#define ue		0x65,0x00
#define uf		0x66,0x00
#define ug		0x67,0x00
#define uh		0x68,0x00
#define ui		0x69,0x00
#define uj		0x6a,0x00
#define uk		0x6b,0x00
#define ul		0x6c,0x00
#define um		0x6d,0x00
#define un		0x6e,0x00
#define uo		0x6f,0x00
#define up		0x70,0x00
#define uq		0x71,0x00
#define ur		0x72,0x00
#define us		0x73,0x00
#define ut		0x74,0x00
#define uu		0x75,0x00
#define uv		0x76,0x00
#define uw		0x77,0x00
#define ux		0x78,0x00
#define uy		0x79,0x00
#define uz		0x7a,0x00

#define uNOT	0x7e,0x00,         // ~
#define uDEL	0x7f,0x00,

#endif
